local addonName = ...
local addon = getglobal(addonName) or CreateFrame("Frame",addonName,UIParent)

local function HideQuickJoinFunc()
	local qj = QuickJoinToastButton
	qj:UnregisterEvent("SOCIAL_QUEUE_UPDATE")
	qj.Toast:SetScript("OnShow", function(self) if HideQuickJoinDB then self:Hide() else self:Show() end end)
	qj.Toast:Hide()
	qj.Toast2:SetScript("OnShow", function(self) if HideQuickJoinDB then self:Hide() else self:Show() end end)
	qj.Toast2:Hide()
end

local function ShowQuickJoinFunc()
	local qj = QuickJoinToastButton
	qj:RegisterEvent("SOCIAL_QUEUE_UPDATE")
	qj.Toast:SetScript("OnShow", function(self) if HideQuickJoinDB then self:Hide() else self:Show() end end)
	qj.Toast:Show()
	qj.Toast2:SetScript("OnShow", function(self) if HideQuickJoinDB then self:Hide() else self:Show() end end)
	qj.Toast2:Show()
end

SLASH_HIDEQUICKJOIN1 = "/quickjoin"
SLASH_HIDEQUICKJOIN2 = "/qj"
SlashCmdList["HIDEQUICKJOIN"] = function(msg)
	if not msg or msg == "" then
		if HideQuickJoinDB then
			HideQuickJoinDB = false
			ShowQuickJoinFunc()
		else
			HideQuickJoinDB = true
			HideQuickJoinFunc()
		end
	else
		msg = string.lower(msg)
		if msg == "hide" then
			HideQuickJoinDB = true
			HideQuickJoinFunc()
		elseif msg == "show" then
			HideQuickJoinDB = false
			ShowQuickJoinFunc()
		end
	end
end

addon:RegisterEvent("ADDON_LOADED")
addon:SetScript("OnEvent",function(self,event,...)
	if event == "ADDON_LOADED" then
		if ... == addonName then
			self:UnregisterEvent("ADDON_LOADED")
			self:RegisterEvent("PLAYER_ENTERING_WORLD")
			
			if HideQuickJoinDB == nil then
				HideQuickJoinDB = true
			end
			
			local Options = getglobal(addonName.."_Options") or CreateFrame("Frame",addonName.."_Options",addon)
			Options.name = "Hide Quick Join"
			local hqj = CreateFrame("CheckButton", addonName.."_Options_HideQuickJoin", Options, "ChatConfigCheckButtonTemplate")
			hqj.name = "Hide"
			hqj:SetChecked(HideQuickJoinDB)
			getglobal(hqj:GetName() .. 'Text'):SetText("Hide quickjoin toast")
			hqj:ClearAllPoints()
			hqj:SetPoint("TOPLEFT",10,-10)

			Options.okay = function()
				HideQuickJoinDB = hqj:GetChecked()
				if HideQuickJoinDB then
					HideQuickJoinFunc()
				else
					ShowQuickJoinFunc()
				end
			end
			Options.cancel = function()
				hqj:SetChecked(HideQuickJoinDB)
			end
			Options.refresh = Options.cancel
			
			InterfaceOptions_AddCategory(Options)
			Options.refresh()
		end
	else
		if event == "PLAYER_ENTERING_WORLD" then
			if HideQuickJoinDB then
				HideQuickJoinFunc()
			end
		end
	end
end)
